//  iPodリモコンをFH-770DVDで使います。
//　AVR　ATmega48用
//Programming　By　亀屋　2013/12/20
// v1.0.0 2013/12/29　1st Release
// v1.0.1 2014/05/10　12MHz水晶使用に変更

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include <util/delay.h>

#define FOSC 12000000 	// 12MHz CPU clock
#define BAUD 19200
#define MYUBRR (FOSC/16/BAUD)-1

#define Play       0x01
#define Volup      0x02
#define Voldown    0x04
#define SkipA      0x08
#define SkipB      0x10
#define EndiPod    0x20

volatile uint8_t RXdata[20];
volatile uint8_t RXcnt=0;
volatile uint8_t TimeOut;
volatile uint16_t LEDflick;
volatile uint8_t point55;
volatile uint8_t TEST;

ISR(USART_RX_vect)
{
	    // 受信データ格納後ポインタ+1
	if((UCSR0A & 0x1C)==0x00){RXdata[RXcnt++] = UDR0;}
	TimeOut=0;
}

SIGNAL(TIMER0_COMPA_vect)
{
        TimeOut++;    // 1ms int
}

void FLICKx(uint8_t ix)
{
	uint8_t i;
	for(i=0;i<ix;i++)
	{
		PORTC=0x00; //LED点灯
		_delay_ms(20);
		PORTC=0x20; //LED消灯
		_delay_ms(20);
	}
}

int main(void)
{
	// USARTセット
	UBRR0H = (uint8_t)(MYUBRR>>8);     // ボーレート上位Byte
	UBRR0L = (uint8_t)MYUBRR;               // ボーレート下位Byte
	UCSR0C = _BV(UCSZ01)|_BV(UCSZ00);        // 1stopbit , 8bit , NP 送信
	UCSR0B = _BV(RXEN0)|_BV(TXEN0)|_BV(RXCIE0);   // 送受信許可,割り込み許可
	
	//ポート設定
	PORTB=0x00;	DDRB=0x3f;					// --oooooo
	PORTC=0x00;	DDRC=0x3f;					// --oooooo
	PORTD=0x01;	DDRD=0xfe;					// oooooooR
	
	//Timer0設定
	TCCR0A=0x02;		//比較一致
	TCCR0B=0x04;		//256分周
	//OCR0A=4;			//一致		1000000/256/4=1000Hz:1ms
	OCR0A=50;			//一致		12000000/256/50=1000Hz:1ms
	TCNT0=0;
	TIMSK0=_BV(OCIE0A);
	
	
	PRR=0xcd;//電力削減レジスタ
	set_sleep_mode (1);//アイドルモード
	sleep_enable();//スリープ許可
	
	sei();		//割り込み許可
	
	
	FLICKx(3);//LED点灯x3
	
	for(;;)
	{
		sleep_cpu();				//CPUアイドルスリープ

		if(RXcnt==0)				//受信なし
		{
			if(TimeOut >= 20)		//受信後20msで初期化
			{
			if(LEDflick >= 1800)
			{
				PORTC=0x00;	//SW-OFF	LED点灯
				if(LEDflick >= 2000){LEDflick=0;}
			}
			else
			{
				PORTC=0x20;	//SW-OFF	LED消灯
			}
			TimeOut=20;
			LEDflick++;
			}
		}
		else
		{
			LEDflick=0;
			if(TimeOut >= 2)		//受信後5msで初期化
			{
			RXcnt=0;
			}
		}

		if(RXcnt>=6)
		{
		
		if(RXdata[0] == 0x55 ) { point55=0; }
		if(RXdata[1] == 0x55 ) { point55=1; }
		if(RXdata[2] == 0x55 ) { point55=2; }
		if(RXdata[3] == 0x55 ) { point55=3; }

			if((RXdata[point55+1]==0x03)&&(RXdata[point55+2]==0x02))
			{
				//FLICKx(1); //LED点灯x1
				switch(RXdata[point55+4])
				{
					case(0x01)://Play/Stop
					PORTC=Play;
					break;
					case(0x02)://Volume+
					PORTC=Volup;
					break;
					case(0x04)://Volume-
					PORTC=Voldown;
					break;
					case(0x08)://Skip>>
					PORTC=SkipA;
					break;
					case(0x10)://<<Skip
					PORTC=SkipB;
					break;
					case(0x00)://End
					//PORTC=EndiPod;
					break;
				}
				//_delay_ms(10);
			}
			RXcnt=0;
			//PORTC=0x00;
		}
	}
}

